IncludeScript("ffa/gamemode/scoreboard.nut")
IncludeScript("ffa/gamemode/assist_manager.nut")
IncludeScript("ffa/gamemode/victory_manager.nut")
IncludeScript("ffa/respawn/_respawn.nut")

Convars.SetValue("tf_weapon_criticals", 0);
Convars.SetValue("mp_friendlyfire", 1);
Convars.SetValue("mp_autoteambalance", 0);
Convars.SetValue("mp_teams_unbalance_limit", 0);
Convars.SetValue("tf_classlimit", 0);
Convars.SetValue("cl_use_tournament_specgui", 0);
Convars.SetValue("mp_forcecamera", 0);
Convars.SetValue("sv_alltalk", 1);
Convars.SetValue("tf_dropped_weapon_lifetime", 0);
Convars.SetValue("mp_scrambleteams_auto", 0);
//Convars.SetValue("mp_disable_respawn_times", 1); //todo re-fix
//Convars.SetValue("mp_respawnwavetime", "1");
Convars.SetValue("sv_vote_issue_autobalance_allowed", "0");
Convars.SetValue("tf_spawn_glows_duration", "0");
Convars.SetValue("tf_avoidteammates", "0");
Convars.SetValue("sv_vote_issue_scramble_teams_allowed", "0");

::team_round_timer <- SpawnEntityFromTable("team_round_timer", {
    targetname = "team_round_timer",
    auto_countdown = 1,
    max_length = 0,
    reset_time = 1,
    show_in_hud = 1,
    show_time_remaining = 1,
    start_paused = 0,
    timer_length = 600,
    StartDisabled = 0,
    "OnFinished": "!self,RunScriptCode,main_script.EndRound(),0,-1"
});

::MERC_SCRIPT <- "ffa/mercenary/_mercenary.nut";

OnGameEvent("post_inventory_application", 0, function(player, params)
{
    if (GetCustomCharacter(player) == null)
        ConvertToCustomCharacter(player, MERC_SCRIPT);
});