//=========================================================================
//Copyright LizardOfOz.
//=========================================================================

IncludeScript("ffa/mercenary/_mercenary.nut");

function AssembleArsenal()
{
    local gungameWeapon = EquipWeapon(GetCurrentGunGameWeapon(self));

    if (gungameWeapon.GetSlot() != 2)
    {
        self.Weapon_Switch(EquipWeapon(GetWeaponTypeByName("crowbar")));
        OnTickEnd(function() {
            self.Weapon_Switch(gungameWeapon);
            RefreshCharacter(false);
        });
    }
    else
    {
        local brick = EquipWeapon(GetWeaponTypeByName("brick"));
        self.Weapon_Switch(brick);
        brick.Kill();
        RunWithDelay(0.1, function()
        {
            self.Weapon_Switch(gungameWeapon);
            RefreshCharacter(false);
        });
    }
}

OnSelfEvent("init_custom_character", 10, function()
{
    //self.AddCustomAttribute("Reload time decreased", 0.75, -1);

    if (!GetPersistentVar("disable_overlays", false))
        self.SetScriptOverlayMaterial("gungame/ui/" + GetCurrentGunGameWeapon(self).names[0] + "_to_" + GetNextGunGameWeapon(self).names[0]);
});

function SwitchToNextWeapon()
{
    for (local i = 0; i < 10; i++)
    {
        local weaponEnt = GetPropEntityArray(self, "m_hMyWeapons", i);
        KillIfValid(weaponEnt);
        SetPropEntityArray(self, "m_hMyWeapons", null, i);
    }
    if (self.InCond(TF_COND_AIMING))
        AssembleArsenal();
    else
    {
        self.RemoveCond(TF_COND_AIMING);
        RunWithDelay(0.01, AssembleArsenal)
    }
}