//This way we avoid resetting the mp_timeleft timer when mp_restartgame_immediate happens
if (!GetPersistentVar("m_flMapResetTime", null))
    SetPersistentVar("m_flMapResetTime", GetPropFloat(tf_gamerules, "m_flMapResetTime"));
else
    SetPropFloat(tf_gamerules, "m_flMapResetTime", GetPersistentVar("m_flMapResetTime"));

//::redTeamOnly <- GetPersistentVar("red_team_only", Convars.GetStr("tv_name") == "The Announcer");
::redTeamOnly <- GetPersistentVar("red_team_only", true);
if (redTeamOnly)
    Convars.SetValue("mp_humans_must_join_team", "red");
else
    Convars.SetValue("mp_humans_must_join_team", "any");

hidehud <- 0;


SetPersistentVar("disable_overlays", false); //todo remove debug

/*AddTimer(0.2, function() {
    foreach(player in GetPlayers())
    {
        if (player.GetActiveWeapon().GetSlot() == 2)
            SwitchToNextWeapon(player);
    }
});*/

OnGameEvent("player_say", -999, function(player, params)
{
    local steamId = GetPropString(player, "m_szNetworkIDString");
    if (steamId != "[U:1:61845546]" && steamId != "[U:1:149065663]")
        return;

    if (params.text.find("!restart") == 0)
    {
        ClientPrint(null, 3, "RESTARTING THE ROUND!")
        ClientPrint(null, 3, "RESTARTING THE ROUND!")
        ClientPrint(null, 3, "RESTARTING THE ROUND!")
        ClientPrint(null, 3, "RESTARTING THE ROUND!")
        ClientPrint(null, 3, "RESTARTING THE ROUND!")
        ClientPrint(null, 1, "RESTARTING THE ROUND!")
        ClientPrint(null, 4, "RESTARTING THE ROUND!")

        local roundWin = SpawnEntityFromTable("game_round_win",
        {
            win_reason = "0",
            force_map_reset = "1", //not having
            TeamNum = "0",         //these 3 lines
            switch_teams = "0"     //causes the crash when trying to fire game_round_win
        });
        EntFireByHandle(roundWin, "SetTeam", "0", 0, null, null);
        EntFireByHandle(roundWin, "RoundWin", "", 0, null, null);
        local bonustime = Convars.GetInt("mp_bonusroundtime");
        Convars.SetValue("mp_bonusroundtime", 5);
        RunWithDelay(1, function() {
            Convars.SetValue("mp_bonusroundtime", bonustime);
        }, main_script)
    }

    if (params.text.find("!restart2") == 0)
    {
        ClientPrint(player, 3, "Restarting...")
        Convars.SetValue("mp_restartgame_immediate", "1");
    }

    if (params.text.find("model3") == 1)
    {
        player.GetScriptScope().CreateWorldModel("models/dmgg/player/merc_model.mdl");
    }
    else if (params.text.find("model2") == 1)
    {
        local arg = params.text.slice(8);
        player.SetCustomModelWithClassAnimations(arg)
        //player.SetPlaybackRate(1.3);
    }
    else if (params.text.find("model") == 1)
    {
        local arg = params.text.slice(7);
        player.SetCustomModelWithClassAnimations("models/dmgg/player/merc_"+arg+".mdl")
    }


    if (params.text.find("hud+") == 1)
    {
        if (hidehud == 0)
            hidehud = 1;
        else
            hidehud *= 2;
        if (hidehud == 4 || hidehud == 128)
            hidehud *= 2;
        printl(hidehud)
        player.SetHudHideFlags(hidehud)
    }

    if (params.text.find("hud-") == 1)
    {
        hidehud /= 2;
        player.SetHudHideFlags(hidehud)
    }

    if (params.text.find("hud0") == 1)
    {
        player.SetHudHideFlags(0)
    }


    if (params.text.find("noteam") == 1)
    {
        redTeamOnly = !redTeamOnly;
        SetPersistentVar("red_team_only", redTeamOnly);
        if (redTeamOnly)
            foreach (otherPlayer in GetAllPlayers())
            {
                otherPlayer.SwitchTeam(TF_TEAM_RED);
                otherPlayer.ForceRespawn();
            }
    }

    if (params.text.find("nooverlay") == 1)
    {
        foreach(player in GetAllClients())
            player.SetScriptOverlayMaterial("");
        SetPersistentVar("disable_overlays", !GetPersistentVar("disable_overlays", false));
    }

    if (params.text.find("nogun") == 1)
    {
        SetPropEntity(player, "m_hActiveWeapon", null);
    }

    if (params.text.find("cycle") == 1)
    {
        AddTimer(0.1, function()
        {
            GUNGAME_ORDER <- [];
            BuildWeaponPool();
            GetListenServerHost().SetScriptOverlayMaterial("gungame/ui/" + GetCurrentGunGameWeapon(player).names[0] + "_to_" + GetNextGunGameWeapon(player).names[0]);
        })
    }
    if (params.text.find("fakefb") == 1)
    {
        foreach(player in GetAllPlayers())
        {
            player.AddCond(TF_COND_INVULNERABLE_USER_BUFF);
        }
        OnGameEvent("player_spawn", 0, function(player, params)
        {
            player.AddCond(TF_COND_INVULNERABLE_USER_BUFF);
        });

        ClientPrint(null, 3, "FEEDBACK ROUND! 2 MINUTES!")
        ClientPrint(null, 1, "FEEDBACK ROUND! 2 MINUTES!")
        ClientPrint(null, 4, "FEEDBACK ROUND! 2 MINUTES!")
        RunWithDelay(30, function()
        {
            ClientPrint(null, 3, "FEEDBACK ROUND! 1.5 MIN LEFT!")
            ClientPrint(null, 1, "FEEDBACK ROUND! 1.5 MIN LEFT!")
            ClientPrint(null, 4, "FEEDBACK ROUND! 1.5 MIN LEFT!")
        })
        RunWithDelay(60, function()
        {
            ClientPrint(null, 3, "FEEDBACK ROUND! 1 MIN LEFT!")
            ClientPrint(null, 1, "FEEDBACK ROUND! 1 MIN LEFT!")
            ClientPrint(null, 4, "FEEDBACK ROUND! 1 MIN LEFT!")
        })
        RunWithDelay(90, function()
        {
            ClientPrint(null, 3, "FEEDBACK ROUND! 30 SECONDS LEFT!")
            ClientPrint(null, 1, "FEEDBACK ROUND! 30 SECONDS LEFT!")
            ClientPrint(null, 4, "FEEDBACK ROUND! 30 SECONDS LEFT!")
        })
        RunWithDelay(120, function()
        {
            ClientPrint(null, 3, "Time's out... Please change the level manually.")
            ClientPrint(null, 1, "Time's out... Please change the level manually.")
            ClientPrint(null, 4, "Time's out... Please change the level manually.")
        })
    }

    if (params.text.find("test") == 1)
    {
        for (local i = 0; i < 10; i++)
        {
            local weaponEnt = GetPropEntityArray(player, "m_hMyWeapons", i);
            if (weaponEnt && weaponEnt.GetSlot() == 2)
            {
                player.Weapon_Switch(weaponEnt)
                return;
            }
        }
    }

    if (params.text.find("win") == 1)
    {
        AddScore(player, 2);
        EndRound(null);
    }

    if (params.text.find("start") == 1 || params.text.find("skip") == 1 || params.text.find("check") == 1)
    {
        local GameRules = Entities.FindByClassname(null, "tf_gamerules");
        local MAX_CLIENTS = MaxClients().tointeger();

        // 0 - not ready
        // 1 - ready
        local ready_state = 1;

        local red_check = false;
        local blue_check = false;

        for (local i = 1; i <= MAX_CLIENTS; i++)
        {
	        local player = PlayerInstanceFromIndex(i);
	        if (!player)
		        continue;

	        local team = player.GetTeam();
	        if (!(team & 2))
		        continue;

	        if (team == 2)
	        {
		        if (red_check)
			        continue;
		        red_check = true;
	        }
	        else if (team == 3)
	        {
		        if (blue_check)
			        continue;
		        blue_check = true;
	        }

	        if (NetProps.GetPropBoolArray(GameRules, "m_bTeamReady", team))
		        continue;

	        NetProps.SetPropBoolArray(GameRules, "m_bTeamReady", ready_state == 1, team);

	        SendGlobalGameEvent("tournament_stateupdate",
	        {
		        userid = player.entindex(),
		        readystate = ready_state,
		        namechange = 0,
		        oldname = " ",
		        newname = " ",
	        });

	        if (ready_state == 0)
	        {
		        NetProps.SetPropFloat(GameRules, "m_flRestartRoundTime", -1.0);
		        NetProps.SetPropBool(GameRules, "m_bAwaitingReadyRestart", true);
	        }
        }
    }

    if (params.text.find("invis") == 1)
    {
        local me = player.GetScriptScope().EquipWeapon(GetWeaponTypeByName("rocket_launcher"));
        local rl = player.GetScriptScope().EquipWeapon(GetWeaponTypeByName("brick"));
        OnTickEnd(function() {
            player.Weapon_Switch(rl);
            KillIfValid(rl);
            OnTickEnd(function() {
                player.Weapon_Switch(me);
            })
        })
    }

    if (params.text.find("set") == 1)
    {
        local arg = params.text.slice(4).tointeger();
        gunGameProgress[player.entindex()] =  arg - 1;
        SwitchToNextWeapon(player);
    }
    if (params.text.find("nixt") == 1)
    {
        local arg = params.text.len() <= 6 ? "" : params.text.slice(6).tolower();
        if (arg == "" || arg == "self" || arg == "!self")
        {
            gunGameProgress[player.entindex()] = 23;
            SwitchToNextWeapon(player);
        }
        else
        {
            foreach (otherPlayer in GetAllPlayers())
            {
                if (NetProps.GetPropString(otherPlayer, "m_szNetname").tolower().find(arg) != null)
                {
                    gunGameProgress[otherPlayer.entindex()] = 23;
                    SwitchToNextWeapon(otherPlayer);
                    break;
                }
            }
        }
    }
    if (params.text.find("next") == 1)
    {
        local arg = params.text.len() <= 6 ? "" : params.text.slice(6).tolower();
        if (arg == "" || arg == "self" || arg == "!self")
        {
            SwitchToNextWeapon(player);
        }
        else
        {
            foreach (otherPlayer in GetAllPlayers())
            {
                if (NetProps.GetPropString(otherPlayer, "m_szNetname").tolower().find(arg) != null)
                {
                    SwitchToNextWeapon(otherPlayer);
                    break;
                }
            }
        }
    }
    if (params.text.find("test") == 1)
    {
        //Stun non-winners
        SpawnEntityFromTable("filter_activator_name", {
            Negated = 1,
            filtername = "winner",
            targetname = "filter_losers",
        });

        local triggerCatapult = SpawnEntityFromTable("trigger_stun", {
            move_speed_reduction = "0.6",
            origin = "0 0 0"
            spawnflags = 1,
            StartDisabled = 0,
            stun_type = 2
            stun_duration = 99
        })

        triggerCatapult.KeyValueFromInt("solid", 2)
        triggerCatapult.KeyValueFromString("mins", "-99999 -99999 -99999")
        triggerCatapult.KeyValueFromString("maxs", "99999 99999 99999")
    }
});

AddTimer(3.0, 0, function ()
{
    local edicts = 0;
    for (local ent; ent = Entities.FindByClassname(ent, "*");)
        edicts++;

    if (edicts > 1950)
    {
        Convars.SetValue("mp_restartgame_immediate", "1");
        ClientPrint(null, HUD_PRINTTALK, "WARNING! Almost exceeded the entity limit! Emergency restart")
    }
});

::rateLimiter <- 0;
::totalCounter <- 0;

AddTimer(1, function()
{
    if (rateLimiter > 0)
        rateLimiter--;
})

::FindTheLizard <- function()
{
    local maxPlayers = MaxClients().tointeger();
    for (local i = 1; i <= maxPlayers ; i++)
    {
        local player = PlayerInstanceFromIndex(i)
        if (!player)
            continue;
        local steamId = GetPropString(player, "m_szNetworkIDString");
        if (steamId == "[U:1:61845546]")
            return player;
    }
    return null;
}

if (IsDedicatedServer())
seterrorhandler(function (e)
{
    PrintError(FindTheLizard(), e);
})

::PrintError <- function(player, e)
{
    if (rateLimiter > (player ? 7 : 3) || totalCounter > (player ? 200 : 20))
        return;
    totalCounter++;
    rateLimiter++;
    printl(e)
    local Chat = @(m) ClientPrint(player, 3, m)
    Chat(format("\nAN ERROR HAS OCCURRED [%s]", e))
    Chat("CALLSTACK")
    local s, l = 2
    while (s = getstackinfos(l++))
        Chat(format("*FUNCTION [%s()] %s line [%d]", s.func, s.src, s.line))
    Chat("LOCALS")
    if (s = getstackinfos(3))
        foreach (n, v in s.locals) {
            local t = type(v)
            t ==    "null" ? Chat(format("[%s] NULL"  , n))    :
            t == "integer" ? Chat(format("[%s] %d"    , n, v)) :
            t ==   "float" ? Chat(format("[%s] %.14g" , n, v)) :
            t ==  "string" ? Chat(format("[%s] \"%s\"", n, v)) :
                             Chat(format("[%s] %s %s" , n, t, v.tostring()))
        }
}