if (!IsValid(safeget(root_table, "game_text_hop_bar", null)))
    ::game_text_hop_bar <- SpawnEntityFromTable("game_text",
    {
        color = "255 255 255",
        color2 = "0 0 0",
        channel = 2,
        effect = 0,
        fadein = 0,
        fadeout = 0,
        fxtime = 0,
        holdtime = 250,
        message = "",
        spawnflags = 0,
        x = 0.715,
        y = 0.935
    });

boostMeter <- 0;
boostVector <- Vector();
hasJumped <- 0;

AddTimer(0.1, function()
{
    if (!self.IsAlive())
        return;

    local bar = "";
    local i = 10;
    for (; i <= clampCeiling(100, boostMeter); i += 10)
        bar += "▰";
    for (; i <= 100; i += 10)
        bar += "▱";
    EntFireByHandle(game_text_hop_bar, "AddOutput", "message " + bar, 0, self, self);
    EntFireByHandle(game_text_hop_bar, "Display", "", 0, self, self);

    if (boostMeter >= 100)
        self.AddCondEx(TF_COND_SPEED_BOOST, 0.3, self);
    self.AddCustomAttribute("move speed bonus",
        1.04 / MERC_MOVESPEED_MULTIPLIER[self.GetPlayerClass()] + boostMeter / 180.0,
        -1);
})

AddTimer(-1, 0, function()
{
    local entIndex = self.entindex();
    if (!GetPropBool(self, "m_Shared.m_bJumping"))
        hasJumped = false;
    else if (!hasJumped)
    {
        hasJumped = true;
        boostMeter = clampCeiling(120, boostMeter + 10);
        BuildSound("jump").Voice().Volume(0.6).SoundLevel(90).Play();
    }

    local velocity = self.GetAbsVelocity();
    local speed2d = velocity.Length2D();
    local velZ = abs(velocity.z);
    velocity.z = 0;
    boostVector.z = 0;
    velocity.Norm();
    boostVector.Norm();
    local deltaVector = velocity - boostVector;
    deltaVector.Norm();
    local newForward = boostVector + deltaVector * 0.1;
    newForward.Norm();
    local dot = velocity.Dot(newForward);
    local dot2 = self.EyeAngles().Forward().Dot(newForward);
    boostVector = newForward;

    if (dot > 0.999 && speed2d > 310 && dot2 > 0.3)
        boostMeter = clampCeiling(120, boostMeter + 0.1);
    else if ((speed2d < 250 || dot < 0.3 || dot2 < 0.3) && velZ < 200)
        boostMeter = clampFloor(0, boostMeter - 2);
});