::GUNGAME_WEAPON_POOLS <- [
        ["rocket_launcher"],
        ["scattergun"],
        ["liberty_launcher"],
        ["tomislav"],
        //["flamethrower"],
        ["grenade_launcher"],
        ["back_scatter"],
        ["loose_cannon"],
        ["sticky_launcher"],
        //["phlogistinator"],
        ["shortstop"],
        ["black_box"],
        ["quickie_launcher"],
        ["shotgun"],
        ["iron_bomber"],
        ["beggars_bazooka"],
        ["soda_popper"],
        //["dragons_fury"],
        ["family_business"],
        ["airstrike"],
        ["sniper_rifle"],
        //["eyelander_and_targe"],
        ["force_a_nature"],
        //["huntsman"],
        ["smg"],
        ["syringe_gun"],
        ["revolver"],
        ["ambassador"],
        ["rescue_ranger"],
        //["righteous_bison", "rescue_ranger", "scorch_shot"],
        ["pistol"],
        //["pocket_pistol"],
        ["golden_crowbar"],
        ["victory"],
]
::fragLimit <- GUNGAME_WEAPON_POOLS.len() - 1;

::GUNGAME_ORDER <- [];

foreach(set in GUNGAME_WEAPON_POOLS)
    GUNGAME_ORDER.push(set[RandomInt(0, set.len() - 1)]);

::GetCurrentGunGameWeapon <- function(player)
{
    local index = clampCeiling(
        gunGameProgress[player.entindex()],
        GUNGAME_ORDER.len() - 1);
    return GetWeaponTypeByName(GUNGAME_ORDER[index]);
}

::GetNextGunGameWeapon <- function(player)
{
    local index = clampCeiling(
        gunGameProgress[player.entindex()] + 1,
        GUNGAME_ORDER.len() - 1);
    return GetWeaponTypeByName(GUNGAME_ORDER[index]);
}
